



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>newCachedThreadPool 的使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">newCachedThreadPool 的使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 20:53:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>newCachedThreadPool的线程池特点：</p>
<p>（1）它是一个可以无限扩大的线程池；它比较适合处理执行时间比较小的任务；corePoolSize为0，maximumPoolSize为无限大，意味着线程数量可以无限大；keepAliveTime为60S，意味着线程空闲时间超过60S就会被杀死；采用SynchronousQueue装等待的任务，这个阻塞队列没有存储空间，这意味着只要有请求到来，就必须要找到一条工作线程处理他，如果当前没有空闲的线程，那么就会再创建一条新的线程。</p>
<p>（2）如果线程池长度超过处理需要，可灵活回收空闲线程，若无可回收，则新建线程。<br />可以看出该线程池会复用空闲的线程，从而减少创建对象和回收对象带来开销。</p>
<p>项目中用到了newCachedThreadPool,查了一下，为啥用这个：</p>
<div>
<pre class="prettyprint linenums">  private static final Logger LOGGER = LoggerFactory.getLogger(AbstractCityAsyncClient.class);

    private static final int QUEUE_SIZE = ;

    private static final int WORKER_COUNT = ;

    private static final ThreadGroup THREAD_GROUP = new ThreadGroup("cityAsyncClientThrceadGroup");

    private static final ExecutorService EXECUTOR_SERVICE = Executors.newCachedThreadPool(new ThreadFactory() {

        private final AtomicInteger threadNumber = new AtomicInteger();

        @Override<br />
        public Thread newThread(Runnable r) {<br />
            return new Thread(THREAD_GROUP, r, "cityAsyncClient-thread-pool-" + threadNumber.getAndIncrement());<br />
        }<br />
    });

 @Override<br />
    public void asyncExecRequest(CityRequest cityRequest) {<br />
        String name = cityRequest.getName();<br />
        BlockingQueue&lt;CityRequest&gt; blockingQueue = requestQueueMap.get(name);<br />
        if (blockingQueue == null) {<br />
            synchronized (requestQueueMap) {<br />
                /* double check */<br />
                blockingQueue = requestQueueMap.get(name);<br />
                if (blockingQueue == null) {<br />
                    blockingQueue = new ArrayBlockingQueue&lt;&gt;(QUEUE_SIZE);<br />
                    requestQueueMap.put(name, blockingQueue);

                    for (int i = ; i &lt; WORKER_COUNT; i++) {<br />
                        EXECUTOR_SERVICE.execute(new Worker(this, blockingQueue));<br />
                    }<br />
                }<br />
            }<br />
        }

        try {<br />
            if (!blockingQueue.offer(cityRequest, 10L, TimeUnit.MILLISECONDS)) {<br />
                execRequest(cityRequest);<br />
            }<br />
        } catch (InterruptedException e) {<br />
            LOGGER.error("{}.asyncExecRequest error.", this.getClass().getSimpleName(), e);<br />
        }<br />
    }</pre>
</div>
<p>之所以要用到newCachedThreadPool的原因是：</p>
<p>主要是考虑到了（a）如果线程池超过长度，可以灵活回收空闲线程，若无可回收，则新建线程，。因为车辆定位信息可能有时候多，有时候少，考虑到复用性的问题，如果线程闲置的话，可以复用。减少损耗系统资源。</p>
<p>(b )它比较适合处理执行时间比较小的任务；我们的任务到了一定上线就会及时处理。（数量1000，等待时间 5000毫秒，也就是说，不管数据过来多少，只要到了1000条或者5秒就发送）</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy2pj29.html">分部方法 partial</a>
		</li>
						<li><a href="https://www.batexi.com/a/390ey6mq.html">Oracle一个事务中的Insert和Update执行顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k7px69.html">fgets函数执行完成后，文件指针如何移动？</a>
		</li>
						<li><a href="https://www.batexi.com/a/390gleo8.html">How to get URL parameters with Javascript&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd41me8.html">ELk 几篇好的文章</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ynjl0q.html">PHP代码审计】 那些年我们一起挖掘SQL注入 - 1&period;什么都没过滤的入门情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok53gp9.html">hdu-5597 GTW likes function&lpar;欧拉函数&plus;找规律&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnymrrq.html">琐碎-hadoop2&period;2&period;0目录结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydxrvxq.html">C&num;中IDisposable学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnmypj8.html">【递推】地铁重组&lpar;subway&rpar; 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1xgj28.html">重写扫雷（基于jQuery） 新手 有不足的地方敬请谅解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wpk59.html">OC基础8：分类和协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrp5xq.html">C&plus;&plus; 虚函数机制学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj3odlq.html">201521123112《Java程序设计》第11周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwr578.html">JavaScript的DOM编程--09--节点的替换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me5r76q.html">工厂方法模式&lpar;Factory Method Pattern&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwdpwy8.html">opencv常用api</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2zylz9.html">更新glibc版本，有问题，有三篇博客的命令看不懂</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwo0dj9.html">Vue父子组件和非父子组件传值问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwyer78.html">SpringMVC集成MongoDb</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8oj6zj5q.html">深入解读MySQL8&period;0 新特性 ：Crash Safe DDL</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjg1nr8.html">mysql&lowbar;8&period;0&period;12环境配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1y6loq.html">命令行程序增加 GUI 外壳</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpewp39.html">原子操作&amp;amp&semi;普通锁&amp;amp&semi;读写锁</a>
			</li>
						<li><a href="https://www.batexi.com/a/950e5zv8.html">Php7&period;3  could not find driver</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp20mzq.html">升级WIN10 &lpar;9879&rpar;后IE无响应的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j4w5l8.html">前端入门24-响应式布局（BootStrap）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj2d3z8.html">PostGIS计算矢量切片&lpar;二&rpar;--按值渲染</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zro2e9.html">jmeter接口测试实战-创建用户</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj4lxe9.html">DVWA 黑客攻防演练（十二） DOM型 XSS 攻击 DOM Based Cross Site Scripting</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
